#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#define F_CPU 8000000UL                         // internal clock set to 8 MHz
#include <stdio.h>

// needed for the ds18b20 sensor
#include <Arduino.h>
#include <OneWire.h>
#include <DallasTemperature.h>
// serial communication
#include "serialneil.h"


#define max_buffer 25

#define serial_port PORTA
#define serial_direction DDRA
#define serial_pins PINA
#define serial_pin_in (1 << PA0)
#define serial_pin_out (1 << PA1)

// picked from https://stackoverflow.com/questions/8257714/how-to-convert-an-int-to-string-in-c/23840699
char* itoa (int16_t value, char *result, int base)
{
    // check that the base if valid
    if (base < 2 || base > 36) { *result = '\0'; return result; }

    char* ptr = result, *ptr1 = result, tmp_char;
    int tmp_value;

    do {
        tmp_value = value;
        value /= base;
        *ptr++ = "zyxwvutsrqponmlkjihgfedcba9876543210123456789abcdefghijklmnopqrstuvwxyz" [35 + (tmp_value - value * base)];
    } while ( value );

    // Apply negative sign
    if (tmp_value < 0) *ptr++ = '-';
    *ptr-- = '\0';
    while (ptr1 < ptr) {
        tmp_char = *ptr;
        *ptr--= *ptr1;
        *ptr1++ = tmp_char;
    }
    return result;
}

// Data wire is plugged into pin 2 on the Arduino
#define ONE_WIRE_BUS 2
// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);
// Pass our oneWire reference to Dallas Temperature. 
DallasTemperature sensors(&oneWire);


int main(void) {
   //
   // main
   //
  //  static char chr;
   static char buffer[max_buffer] = {0};
  //  static int index;
   int16_t temp;
   //
   // set clock divider to /1
   //
   CLKPR = (1 << CLKPCE);
   CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);
   //
   // initialize output pins
   //
  set(serial_port, serial_pin_out);
  output(serial_direction, serial_pin_out);
  sensors.begin();

   //
   // main loop
   //
  //  index = 0;
   while (1) {
      // get_char(&serial_pins, serial_pin_in, &chr);

      sensors.requestTemperatures();  
      // put_string(&serial_port, serial_pin_out, "Temperature is: ");
      put_string(&serial_port, serial_pin_out, itoa(sensors.getTempCByIndex(0), buffer, 10)); // Why "byIndex"? You can have more than one IC on the same bus. 0 refers to the first IC on the wire
      put_string(&serial_port, serial_pin_out, "\n\r");
       _delay_ms(100);
      }
   }